// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/Compartment.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/compartment.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/compartment__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'box'
#include "rc_reason_msgs/msg/detail/box__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Compartment & msg,
  std::ostream & out)
{
  out << "{";
  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: box
  {
    out << "box: ";
    to_flow_style_yaml(msg.box, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Compartment & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: box
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "box:\n";
    to_block_style_yaml(msg.box, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Compartment & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::Compartment & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::Compartment & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::Compartment>()
{
  return "rc_reason_msgs::msg::Compartment";
}

template<>
inline const char * name<rc_reason_msgs::msg::Compartment>()
{
  return "rc_reason_msgs/msg/Compartment";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::Compartment>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Pose>::value && has_fixed_size<rc_reason_msgs::msg::Box>::value> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::Compartment>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Pose>::value && has_bounded_size<rc_reason_msgs::msg::Box>::value> {};

template<>
struct is_message<rc_reason_msgs::msg::Compartment>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__TRAITS_HPP_
