// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/Grasp.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/grasp.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__GRASP__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__GRASP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__Grasp __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__Grasp __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Grasp_
{
  using Type = Grasp_<ContainerAllocator>;

  explicit Grasp_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->uuid = "";
      this->match_uuid = "";
    }
  }

  explicit Grasp_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc),
    uuid(_alloc),
    match_uuid(_alloc),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->uuid = "";
      this->match_uuid = "";
    }
  }

  // field types and members
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id_type id;
  using _uuid_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _uuid_type uuid;
  using _match_uuid_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _match_uuid_type match_uuid;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__uuid(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->uuid = _arg;
    return *this;
  }
  Type & set__match_uuid(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->match_uuid = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::Grasp_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::Grasp_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Grasp_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Grasp_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__Grasp
    std::shared_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__Grasp
    std::shared_ptr<rc_reason_msgs::msg::Grasp_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Grasp_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->uuid != other.uuid) {
      return false;
    }
    if (this->match_uuid != other.match_uuid) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const Grasp_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Grasp_

// alias to use template instance with default allocator
using Grasp =
  rc_reason_msgs::msg::Grasp_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__GRASP__STRUCT_HPP_
