// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/LoadCarrierModel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/load_carrier_model.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/load_carrier_model__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__traits.hpp"
// Member 'rim_thickness'
// Member 'rim_ledge'
#include "rc_reason_msgs/msg/detail/rectangle__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LoadCarrierModel & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: outer_dimensions
  {
    out << "outer_dimensions: ";
    to_flow_style_yaml(msg.outer_dimensions, out);
    out << ", ";
  }

  // member: inner_dimensions
  {
    out << "inner_dimensions: ";
    to_flow_style_yaml(msg.inner_dimensions, out);
    out << ", ";
  }

  // member: rim_thickness
  {
    out << "rim_thickness: ";
    to_flow_style_yaml(msg.rim_thickness, out);
    out << ", ";
  }

  // member: rim_step_height
  {
    out << "rim_step_height: ";
    rosidl_generator_traits::value_to_yaml(msg.rim_step_height, out);
    out << ", ";
  }

  // member: rim_ledge
  {
    out << "rim_ledge: ";
    to_flow_style_yaml(msg.rim_ledge, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: pose_type
  {
    out << "pose_type: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_type, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LoadCarrierModel & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: outer_dimensions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "outer_dimensions:\n";
    to_block_style_yaml(msg.outer_dimensions, out, indentation + 2);
  }

  // member: inner_dimensions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "inner_dimensions:\n";
    to_block_style_yaml(msg.inner_dimensions, out, indentation + 2);
  }

  // member: rim_thickness
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_thickness:\n";
    to_block_style_yaml(msg.rim_thickness, out, indentation + 2);
  }

  // member: rim_step_height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_step_height: ";
    rosidl_generator_traits::value_to_yaml(msg.rim_step_height, out);
    out << "\n";
  }

  // member: rim_ledge
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_ledge:\n";
    to_block_style_yaml(msg.rim_ledge, out, indentation + 2);
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: pose_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_type: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_type, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LoadCarrierModel & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::LoadCarrierModel & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::LoadCarrierModel & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::LoadCarrierModel>()
{
  return "rc_reason_msgs::msg::LoadCarrierModel";
}

template<>
inline const char * name<rc_reason_msgs::msg::LoadCarrierModel>()
{
  return "rc_reason_msgs/msg/LoadCarrierModel";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::LoadCarrierModel>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::LoadCarrierModel>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::LoadCarrierModel>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__TRAITS_HPP_
