// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/RangeValue.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/range_value.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__RANGE_VALUE__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__RANGE_VALUE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/range_value__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RangeValue & msg,
  std::ostream & out)
{
  out << "{";
  // member: min
  {
    out << "min: ";
    rosidl_generator_traits::value_to_yaml(msg.min, out);
    out << ", ";
  }

  // member: max
  {
    out << "max: ";
    rosidl_generator_traits::value_to_yaml(msg.max, out);
    out << ", ";
  }

  // member: mean
  {
    out << "mean: ";
    rosidl_generator_traits::value_to_yaml(msg.mean, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RangeValue & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: min
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min: ";
    rosidl_generator_traits::value_to_yaml(msg.min, out);
    out << "\n";
  }

  // member: max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max: ";
    rosidl_generator_traits::value_to_yaml(msg.max, out);
    out << "\n";
  }

  // member: mean
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mean: ";
    rosidl_generator_traits::value_to_yaml(msg.mean, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RangeValue & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::RangeValue & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::RangeValue & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::RangeValue>()
{
  return "rc_reason_msgs::msg::RangeValue";
}

template<>
inline const char * name<rc_reason_msgs::msg::RangeValue>()
{
  return "rc_reason_msgs/msg/RangeValue";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::RangeValue>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::RangeValue>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rc_reason_msgs::msg::RangeValue>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__RANGE_VALUE__TRAITS_HPP_
