// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/RegionOfInterest2D.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/region_of_interest2_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__msg__RegionOfInterest2D__init(rc_reason_msgs__msg__RegionOfInterest2D * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__RegionOfInterest2D__fini(msg);
    return false;
  }
  // offset_x
  // offset_y
  // width
  // height
  return true;
}

void
rc_reason_msgs__msg__RegionOfInterest2D__fini(rc_reason_msgs__msg__RegionOfInterest2D * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // offset_x
  // offset_y
  // width
  // height
}

bool
rc_reason_msgs__msg__RegionOfInterest2D__are_equal(const rc_reason_msgs__msg__RegionOfInterest2D * lhs, const rc_reason_msgs__msg__RegionOfInterest2D * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // offset_x
  if (lhs->offset_x != rhs->offset_x) {
    return false;
  }
  // offset_y
  if (lhs->offset_y != rhs->offset_y) {
    return false;
  }
  // width
  if (lhs->width != rhs->width) {
    return false;
  }
  // height
  if (lhs->height != rhs->height) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__RegionOfInterest2D__copy(
  const rc_reason_msgs__msg__RegionOfInterest2D * input,
  rc_reason_msgs__msg__RegionOfInterest2D * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // offset_x
  output->offset_x = input->offset_x;
  // offset_y
  output->offset_y = input->offset_y;
  // width
  output->width = input->width;
  // height
  output->height = input->height;
  return true;
}

rc_reason_msgs__msg__RegionOfInterest2D *
rc_reason_msgs__msg__RegionOfInterest2D__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest2D * msg = (rc_reason_msgs__msg__RegionOfInterest2D *)allocator.allocate(sizeof(rc_reason_msgs__msg__RegionOfInterest2D), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__RegionOfInterest2D));
  bool success = rc_reason_msgs__msg__RegionOfInterest2D__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__RegionOfInterest2D__destroy(rc_reason_msgs__msg__RegionOfInterest2D * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__RegionOfInterest2D__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__init(rc_reason_msgs__msg__RegionOfInterest2D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest2D * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__RegionOfInterest2D *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__RegionOfInterest2D), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__RegionOfInterest2D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__RegionOfInterest2D__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__fini(rc_reason_msgs__msg__RegionOfInterest2D__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__RegionOfInterest2D__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__RegionOfInterest2D__Sequence *
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest2D__Sequence * array = (rc_reason_msgs__msg__RegionOfInterest2D__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__RegionOfInterest2D__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__RegionOfInterest2D__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__destroy(rc_reason_msgs__msg__RegionOfInterest2D__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__RegionOfInterest2D__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__are_equal(const rc_reason_msgs__msg__RegionOfInterest2D__Sequence * lhs, const rc_reason_msgs__msg__RegionOfInterest2D__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__RegionOfInterest2D__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__RegionOfInterest2D__Sequence__copy(
  const rc_reason_msgs__msg__RegionOfInterest2D__Sequence * input,
  rc_reason_msgs__msg__RegionOfInterest2D__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__RegionOfInterest2D);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__RegionOfInterest2D * data =
      (rc_reason_msgs__msg__RegionOfInterest2D *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__RegionOfInterest2D__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__RegionOfInterest2D__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__RegionOfInterest2D__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
