// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/RegionOfInterest3D.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/region_of_interest3_d.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST3_D__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST3_D__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"
// Member 'primitive'
#include "shape_msgs/msg/detail/solid_primitive__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__RegionOfInterest3D __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__RegionOfInterest3D __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RegionOfInterest3D_
{
  using Type = RegionOfInterest3D_<ContainerAllocator>;

  explicit RegionOfInterest3D_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init),
    primitive(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
    }
  }

  explicit RegionOfInterest3D_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc),
    pose(_alloc, _init),
    primitive(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
    }
  }

  // field types and members
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id_type id;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;
  using _primitive_type =
    shape_msgs::msg::SolidPrimitive_<ContainerAllocator>;
  _primitive_type primitive;

  // setters for named parameter idiom
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__primitive(
    const shape_msgs::msg::SolidPrimitive_<ContainerAllocator> & _arg)
  {
    this->primitive = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__RegionOfInterest3D
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__RegionOfInterest3D
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest3D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RegionOfInterest3D_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->primitive != other.primitive) {
      return false;
    }
    return true;
  }
  bool operator!=(const RegionOfInterest3D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RegionOfInterest3D_

// alias to use template instance with default allocator
using RegionOfInterest3D =
  rc_reason_msgs::msg::RegionOfInterest3D_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST3_D__STRUCT_HPP_
