// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/GetRegionsOfInterest3D.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/get_regions_of_interest3_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `region_of_interest_ids`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * msg)
{
  if (!msg) {
    return false;
  }
  // region_of_interest_ids
  if (!rosidl_runtime_c__String__Sequence__init(&msg->region_of_interest_ids, 0)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * msg)
{
  if (!msg) {
    return;
  }
  // region_of_interest_ids
  rosidl_runtime_c__String__Sequence__fini(&msg->region_of_interest_ids);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // region_of_interest_ids
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->region_of_interest_ids), &(rhs->region_of_interest_ids)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // region_of_interest_ids
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->region_of_interest_ids), &(output->region_of_interest_ids)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Request *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * msg = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Request *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request));
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Request *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * array = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Request * data =
      (rc_reason_msgs__srv__GetRegionsOfInterest3D_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `regions_of_interest`
#include "rc_reason_msgs/msg/detail/region_of_interest3_d__functions.h"
// Member `return_code`
#include "rc_common_msgs/msg/detail/return_code__functions.h"

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * msg)
{
  if (!msg) {
    return false;
  }
  // regions_of_interest
  if (!rc_reason_msgs__msg__RegionOfInterest3D__Sequence__init(&msg->regions_of_interest, 0)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(msg);
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__init(&msg->return_code)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * msg)
{
  if (!msg) {
    return;
  }
  // regions_of_interest
  rc_reason_msgs__msg__RegionOfInterest3D__Sequence__fini(&msg->regions_of_interest);
  // return_code
  rc_common_msgs__msg__ReturnCode__fini(&msg->return_code);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // regions_of_interest
  if (!rc_reason_msgs__msg__RegionOfInterest3D__Sequence__are_equal(
      &(lhs->regions_of_interest), &(rhs->regions_of_interest)))
  {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__are_equal(
      &(lhs->return_code), &(rhs->return_code)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // regions_of_interest
  if (!rc_reason_msgs__msg__RegionOfInterest3D__Sequence__copy(
      &(input->regions_of_interest), &(output->regions_of_interest)))
  {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__copy(
      &(input->return_code), &(output->return_code)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Response *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * msg = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Response *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response));
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Response *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * array = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Response * data =
      (rc_reason_msgs__srv__GetRegionsOfInterest3D_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "rc_reason_msgs/srv/detail/get_regions_of_interest3_d__functions.h"

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(msg);
    return false;
  }
  // request
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__init(&msg->request, 0)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(msg);
    return false;
  }
  // response
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__init(&msg->response, 0)) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__fini(&msg->request);
  // response
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__fini(&msg->response);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Event *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * msg = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Event *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event));
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__init(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Event *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__fini(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence *
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * array = (rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__destroy(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__are_equal(const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * lhs, const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence__copy(
  const rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * input,
  rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__GetRegionsOfInterest3D_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__GetRegionsOfInterest3D_Event * data =
      (rc_reason_msgs__srv__GetRegionsOfInterest3D_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__GetRegionsOfInterest3D_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
