// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/HandEyeCalibration.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/hand_eye_calibration.h"


#ifndef RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/HandEyeCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Request
{
  uint8_t structure_needs_at_least_one_member;
} rc_reason_msgs__srv__HandEyeCalibration_Request;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibration_Request.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibration_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/HandEyeCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Response
{
  bool success;
  /// Internal status:
  /// 0: Valid calibration returned
  /// 1: Not enough poses
  /// 2: Calibration result is not available
  int32_t status;
  /// Human readable message, for development
  rosidl_runtime_c__String message;
  /// Relative pose of grid with respect to the frame for which the pose was given in the request of SetCalibrationPose
  geometry_msgs__msg__Pose pose;
  /// Calibration residual error
  double error;
  /// Expected translation error given in meter
  double translation_error_meter;
  /// Expected rotation error in degrees
  double rotation_error_degree;
  /// True if calibration was done with sensor mounted on robot
  bool robot_mounted;
} rc_reason_msgs__srv__HandEyeCalibration_Response;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibration_Response.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibration_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__HandEyeCalibration_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__HandEyeCalibration_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/HandEyeCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence request;
  rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence response;
} rc_reason_msgs__srv__HandEyeCalibration_Event;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibration_Event.
typedef struct rc_reason_msgs__srv__HandEyeCalibration_Event__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibration_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibration_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_H_
