// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/HandEyeCalibrationTrigger.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/hand_eye_calibration_trigger.hpp"


#ifndef RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/hand_eye_calibration_trigger__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const HandEyeCalibrationTrigger_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HandEyeCalibrationTrigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HandEyeCalibrationTrigger_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>()
{
  return "rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>()
{
  return "rc_reason_msgs/srv/HandEyeCalibrationTrigger_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const HandEyeCalibrationTrigger_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HandEyeCalibrationTrigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HandEyeCalibrationTrigger_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>()
{
  return "rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>()
{
  return "rc_reason_msgs/srv/HandEyeCalibrationTrigger_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const HandEyeCalibrationTrigger_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HandEyeCalibrationTrigger_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HandEyeCalibrationTrigger_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event>()
{
  return "rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event>()
{
  return "rc_reason_msgs/srv/HandEyeCalibrationTrigger_Event";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event>
  : std::integral_constant<bool, has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>::value && has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibrationTrigger>()
{
  return "rc_reason_msgs::srv::HandEyeCalibrationTrigger";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibrationTrigger>()
{
  return "rc_reason_msgs/srv/HandEyeCalibrationTrigger";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::HandEyeCalibrationTrigger>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::HandEyeCalibrationTrigger_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__TRAITS_HPP_
