// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/LoadCarrierModel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/load_carrier_model.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__struct.hpp"
// Member 'rim_thickness'
// Member 'rim_ledge'
#include "rc_reason_msgs/msg/detail/rectangle__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__LoadCarrierModel __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__LoadCarrierModel __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LoadCarrierModel_
{
  using Type = LoadCarrierModel_<ContainerAllocator>;

  explicit LoadCarrierModel_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : outer_dimensions(_init),
    inner_dimensions(_init),
    rim_thickness(_init),
    rim_ledge(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->type = "";
      this->rim_step_height = 0.0;
      this->pose_type = "";
    }
  }

  explicit LoadCarrierModel_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc),
    type(_alloc),
    outer_dimensions(_alloc, _init),
    inner_dimensions(_alloc, _init),
    rim_thickness(_alloc, _init),
    rim_ledge(_alloc, _init),
    pose(_alloc, _init),
    pose_type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->type = "";
      this->rim_step_height = 0.0;
      this->pose_type = "";
    }
  }

  // field types and members
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id_type id;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _outer_dimensions_type =
    rc_reason_msgs::msg::Box_<ContainerAllocator>;
  _outer_dimensions_type outer_dimensions;
  using _inner_dimensions_type =
    rc_reason_msgs::msg::Box_<ContainerAllocator>;
  _inner_dimensions_type inner_dimensions;
  using _rim_thickness_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _rim_thickness_type rim_thickness;
  using _rim_step_height_type =
    double;
  _rim_step_height_type rim_step_height;
  using _rim_ledge_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _rim_ledge_type rim_ledge;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;
  using _pose_type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _pose_type_type pose_type;

  // setters for named parameter idiom
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__outer_dimensions(
    const rc_reason_msgs::msg::Box_<ContainerAllocator> & _arg)
  {
    this->outer_dimensions = _arg;
    return *this;
  }
  Type & set__inner_dimensions(
    const rc_reason_msgs::msg::Box_<ContainerAllocator> & _arg)
  {
    this->inner_dimensions = _arg;
    return *this;
  }
  Type & set__rim_thickness(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->rim_thickness = _arg;
    return *this;
  }
  Type & set__rim_step_height(
    const double & _arg)
  {
    this->rim_step_height = _arg;
    return *this;
  }
  Type & set__rim_ledge(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->rim_ledge = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__pose_type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->pose_type = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__LoadCarrierModel
    std::shared_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__LoadCarrierModel
    std::shared_ptr<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LoadCarrierModel_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->outer_dimensions != other.outer_dimensions) {
      return false;
    }
    if (this->inner_dimensions != other.inner_dimensions) {
      return false;
    }
    if (this->rim_thickness != other.rim_thickness) {
      return false;
    }
    if (this->rim_step_height != other.rim_step_height) {
      return false;
    }
    if (this->rim_ledge != other.rim_ledge) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->pose_type != other.pose_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const LoadCarrierModel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LoadCarrierModel_

// alias to use template instance with default allocator
using LoadCarrierModel =
  rc_reason_msgs::msg::LoadCarrierModel_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_MODEL__STRUCT_HPP_
