// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/Match.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/match.h"


#ifndef RC_REASON_MSGS__MSG__DETAIL__MATCH__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__MATCH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'template_id'
// Member 'uuid'
// Member 'grasp_uuids'
#include "rosidl_runtime_c/string.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in msg/Match in the package rc_reason_msgs.
/**
  * id of template which was matched
 */
typedef struct rc_reason_msgs__msg__Match
{
  rosidl_runtime_c__String template_id;
  /// unique id of this match
  rosidl_runtime_c__String uuid;
  geometry_msgs__msg__PoseStamped pose;
  /// associated grasps
  rosidl_runtime_c__String__Sequence grasp_uuids;
  /// how well the object matches the template (-1 if not available)
  double score;
} rc_reason_msgs__msg__Match;

// Struct for a sequence of rc_reason_msgs__msg__Match.
typedef struct rc_reason_msgs__msg__Match__Sequence
{
  rc_reason_msgs__msg__Match * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__Match__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__MATCH__STRUCT_H_
