// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rc_reason_msgs:srv/DetectItems.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/detect_items.hpp"


#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__BUILDER_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rc_reason_msgs/srv/detail/detect_items__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_DetectItems_Request_robot_pose
{
public:
  explicit Init_DetectItems_Request_robot_pose(::rc_reason_msgs::srv::DetectItems_Request & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::DetectItems_Request robot_pose(::rc_reason_msgs::srv::DetectItems_Request::_robot_pose_type arg)
  {
    msg_.robot_pose = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

class Init_DetectItems_Request_item_models
{
public:
  explicit Init_DetectItems_Request_item_models(::rc_reason_msgs::srv::DetectItems_Request & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Request_robot_pose item_models(::rc_reason_msgs::srv::DetectItems_Request::_item_models_type arg)
  {
    msg_.item_models = std::move(arg);
    return Init_DetectItems_Request_robot_pose(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

class Init_DetectItems_Request_load_carrier_compartment
{
public:
  explicit Init_DetectItems_Request_load_carrier_compartment(::rc_reason_msgs::srv::DetectItems_Request & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Request_item_models load_carrier_compartment(::rc_reason_msgs::srv::DetectItems_Request::_load_carrier_compartment_type arg)
  {
    msg_.load_carrier_compartment = std::move(arg);
    return Init_DetectItems_Request_item_models(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

class Init_DetectItems_Request_load_carrier_id
{
public:
  explicit Init_DetectItems_Request_load_carrier_id(::rc_reason_msgs::srv::DetectItems_Request & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Request_load_carrier_compartment load_carrier_id(::rc_reason_msgs::srv::DetectItems_Request::_load_carrier_id_type arg)
  {
    msg_.load_carrier_id = std::move(arg);
    return Init_DetectItems_Request_load_carrier_compartment(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

class Init_DetectItems_Request_region_of_interest_id
{
public:
  explicit Init_DetectItems_Request_region_of_interest_id(::rc_reason_msgs::srv::DetectItems_Request & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Request_load_carrier_id region_of_interest_id(::rc_reason_msgs::srv::DetectItems_Request::_region_of_interest_id_type arg)
  {
    msg_.region_of_interest_id = std::move(arg);
    return Init_DetectItems_Request_load_carrier_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

class Init_DetectItems_Request_pose_frame
{
public:
  Init_DetectItems_Request_pose_frame()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_DetectItems_Request_region_of_interest_id pose_frame(::rc_reason_msgs::srv::DetectItems_Request::_pose_frame_type arg)
  {
    msg_.pose_frame = std::move(arg);
    return Init_DetectItems_Request_region_of_interest_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::DetectItems_Request>()
{
  return rc_reason_msgs::srv::builder::Init_DetectItems_Request_pose_frame();
}

}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_DetectItems_Response_return_code
{
public:
  explicit Init_DetectItems_Response_return_code(::rc_reason_msgs::srv::DetectItems_Response & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::DetectItems_Response return_code(::rc_reason_msgs::srv::DetectItems_Response::_return_code_type arg)
  {
    msg_.return_code = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Response msg_;
};

class Init_DetectItems_Response_load_carriers
{
public:
  explicit Init_DetectItems_Response_load_carriers(::rc_reason_msgs::srv::DetectItems_Response & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Response_return_code load_carriers(::rc_reason_msgs::srv::DetectItems_Response::_load_carriers_type arg)
  {
    msg_.load_carriers = std::move(arg);
    return Init_DetectItems_Response_return_code(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Response msg_;
};

class Init_DetectItems_Response_items
{
public:
  explicit Init_DetectItems_Response_items(::rc_reason_msgs::srv::DetectItems_Response & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Response_load_carriers items(::rc_reason_msgs::srv::DetectItems_Response::_items_type arg)
  {
    msg_.items = std::move(arg);
    return Init_DetectItems_Response_load_carriers(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Response msg_;
};

class Init_DetectItems_Response_timestamp
{
public:
  Init_DetectItems_Response_timestamp()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_DetectItems_Response_items timestamp(::rc_reason_msgs::srv::DetectItems_Response::_timestamp_type arg)
  {
    msg_.timestamp = std::move(arg);
    return Init_DetectItems_Response_items(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::DetectItems_Response>()
{
  return rc_reason_msgs::srv::builder::Init_DetectItems_Response_timestamp();
}

}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_DetectItems_Event_response
{
public:
  explicit Init_DetectItems_Event_response(::rc_reason_msgs::srv::DetectItems_Event & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::DetectItems_Event response(::rc_reason_msgs::srv::DetectItems_Event::_response_type arg)
  {
    msg_.response = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Event msg_;
};

class Init_DetectItems_Event_request
{
public:
  explicit Init_DetectItems_Event_request(::rc_reason_msgs::srv::DetectItems_Event & msg)
  : msg_(msg)
  {}
  Init_DetectItems_Event_response request(::rc_reason_msgs::srv::DetectItems_Event::_request_type arg)
  {
    msg_.request = std::move(arg);
    return Init_DetectItems_Event_response(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Event msg_;
};

class Init_DetectItems_Event_info
{
public:
  Init_DetectItems_Event_info()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_DetectItems_Event_request info(::rc_reason_msgs::srv::DetectItems_Event::_info_type arg)
  {
    msg_.info = std::move(arg);
    return Init_DetectItems_Event_request(msg_);
  }

private:
  ::rc_reason_msgs::srv::DetectItems_Event msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::DetectItems_Event>()
{
  return rc_reason_msgs::srv::builder::Init_DetectItems_Event_info();
}

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__BUILDER_HPP_
