// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/DetectItems.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/detect_items.hpp"


#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__struct.hpp"
// Member 'item_models'
#include "rc_reason_msgs/msg/detail/item_model__struct.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectItems_Request_
{
  using Type = DetectItems_Request_<ContainerAllocator>;

  explicit DetectItems_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : load_carrier_compartment(_init),
    robot_pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
      this->region_of_interest_id = "";
      this->load_carrier_id = "";
    }
  }

  explicit DetectItems_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose_frame(_alloc),
    region_of_interest_id(_alloc),
    load_carrier_id(_alloc),
    load_carrier_compartment(_alloc, _init),
    robot_pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
      this->region_of_interest_id = "";
      this->load_carrier_id = "";
    }
  }

  // field types and members
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _pose_frame_type pose_frame;
  using _region_of_interest_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _region_of_interest_id_type region_of_interest_id;
  using _load_carrier_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _load_carrier_id_type load_carrier_id;
  using _load_carrier_compartment_type =
    rc_reason_msgs::msg::Compartment_<ContainerAllocator>;
  _load_carrier_compartment_type load_carrier_compartment;
  using _item_models_type =
    std::vector<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>>;
  _item_models_type item_models;
  using _robot_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _robot_pose_type robot_pose;

  // setters for named parameter idiom
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__region_of_interest_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->region_of_interest_id = _arg;
    return *this;
  }
  Type & set__load_carrier_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->load_carrier_id = _arg;
    return *this;
  }
  Type & set__load_carrier_compartment(
    const rc_reason_msgs::msg::Compartment_<ContainerAllocator> & _arg)
  {
    this->load_carrier_compartment = _arg;
    return *this;
  }
  Type & set__item_models(
    const std::vector<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>> & _arg)
  {
    this->item_models = _arg;
    return *this;
  }
  Type & set__robot_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->robot_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Request
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Request
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectItems_Request_ & other) const
  {
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->region_of_interest_id != other.region_of_interest_id) {
      return false;
    }
    if (this->load_carrier_id != other.load_carrier_id) {
      return false;
    }
    if (this->load_carrier_compartment != other.load_carrier_compartment) {
      return false;
    }
    if (this->item_models != other.item_models) {
      return false;
    }
    if (this->robot_pose != other.robot_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectItems_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectItems_Request_

// alias to use template instance with default allocator
using DetectItems_Request =
  rc_reason_msgs::srv::DetectItems_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'items'
#include "rc_reason_msgs/msg/detail/item__struct.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectItems_Response_
{
  using Type = DetectItems_Response_<ContainerAllocator>;

  explicit DetectItems_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    return_code(_init)
  {
    (void)_init;
  }

  explicit DetectItems_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    return_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _items_type =
    std::vector<rc_reason_msgs::msg::Item_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Item_<ContainerAllocator>>>;
  _items_type items;
  using _load_carriers_type =
    std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>>;
  _load_carriers_type load_carriers;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__items(
    const std::vector<rc_reason_msgs::msg::Item_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Item_<ContainerAllocator>>> & _arg)
  {
    this->items = _arg;
    return *this;
  }
  Type & set__load_carriers(
    const std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>> & _arg)
  {
    this->load_carriers = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Response
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Response
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectItems_Response_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->items != other.items) {
      return false;
    }
    if (this->load_carriers != other.load_carriers) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectItems_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectItems_Response_

// alias to use template instance with default allocator
using DetectItems_Response =
  rc_reason_msgs::srv::DetectItems_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Event __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DetectItems_Event __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectItems_Event_
{
  using Type = DetectItems_Event_<ContainerAllocator>;

  explicit DetectItems_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit DetectItems_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::DetectItems_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::DetectItems_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Event
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DetectItems_Event
    std::shared_ptr<rc_reason_msgs::srv::DetectItems_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectItems_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectItems_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectItems_Event_

// alias to use template instance with default allocator
using DetectItems_Event =
  rc_reason_msgs::srv::DetectItems_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct DetectItems
{
  using Request = rc_reason_msgs::srv::DetectItems_Request;
  using Response = rc_reason_msgs::srv::DetectItems_Response;
  using Event = rc_reason_msgs::srv::DetectItems_Event;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_HPP_
